- Aldebaran documentation |
- C++ Libraries |
- index

libqi-api 2.8.7.4

- Main Page
- Related Pages
- Namespaces
- Classes
- Files
- Examples

- Class List
- Class Hierarchy
- Class Members

All Classes Namespaces Files Functions Variables Typedefs Enumerations Enumerator Friends Macros Pages
Public Member Functions | List of all members
qi::detail::StaticObjectTypeBase Class Reference

`#include <staticobjecttype.hpp>`

## Public Member Functions
void | initialize (const MetaObject &mo, const ObjectTypeData &data)
const TypeInfo & | info () override
| Get the TypeInfo corresponding to this type. More...
const MetaObject & | metaObject (void *instance) override
ObjectUid | uid (void *instance) const override
qi::Future< AnyReference > | metaCall (void *instance, AnyObject context, unsigned int method, const GenericFunctionParameters &params, MetaCallType callType, Signature returnSignature) override
void | metaPost (void *instance, AnyObject context, unsigned int signal, const GenericFunctionParameters &params) override
qi::Future< SignalLink > | connect (void *instance, AnyObject context, unsigned int event, const SignalSubscriber &subscriber) override
qi::Future< void > | disconnect (void *instance, AnyObject context, SignalLink linkId) override
| Disconnect an event link. Returns if disconnection was successful. More...
qi::Future< AnyValue > | property (void *instance, AnyObject context, unsigned int id) override
qi::Future< void > | setProperty (void *instance, AnyObject context, unsigned int id, AnyValue value) override
const std::vector< std::pair < TypeInterface *, std::ptrdiff_t > > & | parentTypes () override
void * | initializeStorage (void *) override
void * | ptrFromStorage (void **) override
void * | clone (void *inst) override
| Allocate a storage and copy the value given as an argument. More...
void | destroy (void *) override
| Free all resources of a storage. More...
bool | less (void *a, void *b) override
Public Member Functions inherited from qi::ObjectTypeInterface
virtual TypeKind | kind ()
std::ptrdiff_t | inherits (TypeInterface *other)
Public Member Functions inherited from qi::TypeInterface
virtual | ~TypeInterface ()=default
const char * | infoString ()
qi::Signature | signature (void *storage=nullptr, bool resolveDynamic=false)

## Additional Inherited Members
Static Public Member Functions inherited from qi::TypeInterface
static TypeInterface * | fromSignature (const qi::Signature &sig)
Static Public Attributes inherited from qi::ObjectTypeInterface
static const auto | INHERITS_FAILED = PTRDIFF_MAX

## Detailed Description

One instance of this class represents one C++ class

To avoid exposing this class, which means not being templated by the class type, we just store the two things we need in an erased way:

- Manageable accessor
- typeinfo

Definition at line 61 of file staticobjecttype.hpp.

## Member Function Documentation

void* qi::detail::StaticObjectTypeBase::clone | ( | void * |  | ) |
| override virtual

Allocate a storage and copy the value given as an argument.

Implements qi::TypeInterface.

qi::Future<SignalLink> qi::detail::StaticObjectTypeBase::connect | ( | void * | instance,
|  | AnyObject | context,
|  | unsigned int | event,
|  | const SignalSubscriber & | subscriber
| ) |  |
| override virtual

Implements qi::ObjectTypeInterface.

void qi::detail::StaticObjectTypeBase::destroy | ( | void * |  | ) |
| override virtual

Free all resources of a storage.

Implements qi::TypeInterface.

qi::Future<void> qi::detail::StaticObjectTypeBase::disconnect | ( | void * | instance,
|  | AnyObject | context,
|  | SignalLink | linkId
| ) |  |
| override virtual

Disconnect an event link. Returns if disconnection was successful.

Implements qi::ObjectTypeInterface.

const TypeInfo& qi::detail::StaticObjectTypeBase::info | ( |  | ) |
| override virtual

Get the TypeInfo corresponding to this type.

Implements qi::TypeInterface.

void qi::detail::StaticObjectTypeBase::initialize | ( | const MetaObject & | mo,
|  | const ObjectTypeData & | data
| ) |  |

void* qi::detail::StaticObjectTypeBase::initializeStorage | ( | void * | ptr | ) |
| override virtual

Initialize and return a new storage, from nothing or a T*.

If ptr is not null, it should be used as a storage (the method can usually just return ptr in that case).

Implements qi::TypeInterface.

bool qi::detail::StaticObjectTypeBase::less | ( | void * | a,
|  | void * | b
| ) |  |
| override virtual

Return true if a is less than b

Less must always work: compare pointers if you have to.

Implements qi::TypeInterface.

qi::Future<AnyReference> qi::detail::StaticObjectTypeBase::metaCall | ( | void * | instance,
|  | AnyObject | context,
|  | unsigned int | method,
|  | const GenericFunctionParameters & | params,
|  | MetaCallType | callType,
|  | Signature | returnSignature
| ) |  |
| override virtual

Implements qi::ObjectTypeInterface.

const MetaObject& qi::detail::StaticObjectTypeBase::metaObject | ( | void * | instance | ) |
| override virtual

Implements qi::ObjectTypeInterface.

void qi::detail::StaticObjectTypeBase::metaPost | ( | void * | instance,
|  | AnyObject | context,
|  | unsigned int | signal,
|  | const GenericFunctionParameters & | params
| ) |  |
| override virtual

Implements qi::ObjectTypeInterface.

const std::vector<std::pair<TypeInterface*, std::ptrdiff_t> >& qi::detail::StaticObjectTypeBase::parentTypes | ( |  | ) |
| override virtual

Returns
  parent types with associated pointer offset

Implements qi::ObjectTypeInterface.

qi::Future<AnyValue> qi::detail::StaticObjectTypeBase::property | ( | void * | instance,
|  | AnyObject | context,
|  | unsigned int | id
| ) |  |
| override virtual

Implements qi::ObjectTypeInterface.

void* qi::detail::StaticObjectTypeBase::ptrFromStorage | ( | void ** |  | ) |
| override virtual

Get pointer to type from pointer to storage.

This allows for storing an integer value (for instance) directily into the pointer and avoid an allocation.

This method should be called on storage before casting it to a specific type.

Implements qi::TypeInterface.

qi::Future<void> qi::detail::StaticObjectTypeBase::setProperty | ( | void * | instance,
|  | AnyObject | context,
|  | unsigned int | id,
|  | AnyValue | value
| ) |  |
| override virtual

Implements qi::ObjectTypeInterface.

ObjectUid qi::detail::StaticObjectTypeBase::uid | ( | void * | instance | ) | const
| override virtual

Implements qi::ObjectTypeInterface.

The documentation for this class was generated from the following file:

- /home/opennao/work/release-2.8/sdk/libqi/qi/type/detail/staticobjecttype.hpp